﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=\%PROJECT_NAME%.zip

'B4A ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4A\%PROJECT_NAME%.b4a 
'B4i ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4i\%PROJECT_NAME%.b4i 
'B4J ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4J\%PROJECT_NAME%.b4j

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Type CircleData (Angle As Double, Radius As Int, Color As Int)
	Private pnlCircles, pnlCursor As B4XView
	Private cvsCircles, cvsCursor As B4XCanvas
	Private CenterX, CenterY, BigRadius, OffsetY, CurrectCircleIndex As Int
	Private Delta, DAngle As Double	
	Private lstCircles As List
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	cvsCircles.Initialize(pnlCircles)
	cvsCursor.Initialize(pnlCursor)
	
	CenterX = pnlCircles.Width / 2
	CenterY = pnlCircles.Height / 2
	BigRadius = 120dip
	Delta = 8dip		'snap distance in pixels
	DAngle = Delta * 180 / cPI / BigRadius	'snap angle in degrees
	
#If B4J
	OffsetY = 0
#Else
	OffsetY = 50dip
#End If
	
	InitCircles
	DrawCircles
End Sub

Private Sub InitCircles
	Private Angle As Double
	Private R1, R2 As Int
	
	R1 = 4dip
	R2 = 6dip
	
	lstCircles.Initialize
	
	cvsCircles.DrawCircle(CenterX, CenterY, BigRadius, xui.Color_Black, False, 1dip)
	For Angle = 0 To 350 Step 10
		Private Circle As CircleData
		Circle.Initialize
		Circle.Angle = Angle
		If (Angle Mod 40) = 0 Then
			Circle.Radius = R2
			Circle.Color = xui.Color_Red
		Else
			Circle.Radius = R1
			Circle.Color = xui.Color_RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
		End If
		lstCircles.Add(Circle)
	Next
End Sub

Private Sub DrawCircles
	cvsCircles.DrawCircle(CenterX, CenterY, BigRadius, xui.Color_Black, False, 1dip)
	For i = 0 To lstCircles.Size - 1
		Private Circle As CircleData
		Circle = lstCircles.Get(i)
		DrawCircle(Circle.Angle, Circle.Radius, Circle.Color)
	Next
End Sub

Private Sub DrawCircle(Angle As Double, Radius As Int, Color As Int)
	Private x, y As Int
	
	x = CenterX + BigRadius * CosD(Angle)
	y = CenterY + BigRadius * SinD(Angle)
	
	cvsCircles.DrawCircle(x, y, Radius, Color, True, 1dip)
End Sub

Private Sub pnlCursor_Touch (Action As Int, X As Float, Y As Float)
	Y = Y - OffsetY
	Select Action
		Case pnlCursor.TOUCH_ACTION_DOWN, pnlCursor.TOUCH_ACTION_MOVE
			DrawCursor(X, Y)
			CheckCircle(X, Y)
		Case pnlCursor.TOUCH_ACTION_UP
			HideCursor
			If CurrectCircleIndex > -1 Then
				CircleTouched(CurrectCircleIndex)
			End If
	End Select
End Sub

Private Sub CircleTouched(Index As Int)
	Private Circle As CircleData
	Circle = lstCircles.Get(CurrectCircleIndex)
	Log("Index: = " & Index & "  Angle = " & Circle.Angle)
End Sub

Private Sub DrawCursor(X As Int, Y As Int)
	Private CrossLength As Int

	HideCursor
	
	CrossLength = 10dip
	cvsCursor.DrawLine(X - CrossLength, Y, X + CrossLength, Y, xui.Color_Red, 1dip)
	cvsCursor.DrawLine(X, Y - CrossLength, X, Y + CrossLength, xui.Color_Red, 1dip)
	If CurrectCircleIndex >= 0 Then
		Private Circle As CircleData
		
		Circle = lstCircles.Get(CurrectCircleIndex)
		x = CenterX + BigRadius * CosD(Circle.Angle)
		y = CenterY + BigRadius * SinD(Circle.Angle)

		cvsCursor.DrawCircle(X, Y, Circle.Radius + 2dip, xui.Color_Blue, False, 2dip)
	End If
	cvsCursor.Invalidate
End Sub

Private Sub HideCursor
	cvsCursor.ClearRect(cvsCursor.TargetRect)
End Sub

Private Sub CheckCircle(X As Int, Y As Int)
	Private Radius, AngleTouch As Double
	Radius = Sqrt((X - CenterX) * (X - CenterX) + (Y - CenterY) * (Y - CenterY))	'touch radius
	CurrectCircleIndex = -1
	If Abs(Radius - BigRadius) <= Delta Then	'checks if the cursor is near the big cicle
		AngleTouch = ATan2D(Y - CenterY, X - CenterX)	'cursor angle
		If AngleTouch < 0 Then	'Atan2 returns angles between -180 and + 180 degrees
			If AngleTouch > -DAngle Then
				AngleTouch = 0	'near 0, the angle can be 0.xxx or 359.xxx
			Else
				AngleTouch = 360 + AngleTouch	'converts the -180 - +180 range to 0 - 360
			End If
		End If
		For i = 0 To lstCircles.Size - 1
			Private Circle As CircleData
			Circle = lstCircles.Get(i)
			If Abs(AngleTouch - Circle.Angle) <= DAngle Then
				CurrectCircleIndex = i
				Exit
			End If
		Next
	End If
End Sub
